<?php

namespace http://www.peoplevox.net/\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Save ServiceType
 * @subpackage Services
 * @Authors Georgi Georgiev, Rihards @dExIT@ Mantejs
 * @Version 0.1
 * @Date 14/06/2018
 */
class Save extends AbstractSoapClientBase
{
    /**
     * Sets the UserSessionCredentials SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \http://www.peoplevox.net/\StructType\UserSessionCredentials $userSessionCredentials
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderUserSessionCredentials(\http://www.peoplevox.net/\StructType\UserSessionCredentials $userSessionCredentials, $nameSpace = 'http://www.peoplevox.net/', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'UserSessionCredentials', $userSessionCredentials, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named SaveData
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: UserSessionCredentials
     * - SOAPHeaderNamespaces: http://www.peoplevox.net/
     * - SOAPHeaderTypes: \http://www.peoplevox.net/\StructType\UserSessionCredentials
     * - SOAPHeaders: required
     * - documentation: Import data into PeopleVox system.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \http://www.peoplevox.net/\StructType\SaveData $parameters
     * @return \http://www.peoplevox.net/\StructType\SaveDataResponse|bool
     */
    public function SaveData(\http://www.peoplevox.net/\StructType\SaveData $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SaveData($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \http://www.peoplevox.net/\StructType\SaveDataResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
