<?php

namespace http://www.peoplevox.net/\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Subscribe ServiceType
 * @subpackage Services
 * @Authors Georgi Georgiev, Rihards @dExIT@ Mantejs
 * @Version 0.1
 * @Date 14/06/2018
 */
class Subscribe extends AbstractSoapClientBase
{
    /**
     * Sets the UserSessionCredentials SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \http://www.peoplevox.net/\StructType\UserSessionCredentials $userSessionCredentials
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderUserSessionCredentials(\http://www.peoplevox.net/\StructType\UserSessionCredentials $userSessionCredentials, $nameSpace = 'http://www.peoplevox.net/', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'UserSessionCredentials', $userSessionCredentials, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named SubscribeEvent
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: UserSessionCredentials
     * - SOAPHeaderNamespaces: http://www.peoplevox.net/
     * - SOAPHeaderTypes: \http://www.peoplevox.net/\StructType\UserSessionCredentials
     * - SOAPHeaders: required
     * - documentation: Subscribe to PeopleVox system events.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \http://www.peoplevox.net/\StructType\SubscribeEvent $parameters
     * @return \http://www.peoplevox.net/\StructType\SubscribeEventResponse|bool
     */
    public function SubscribeEvent(\http://www.peoplevox.net/\StructType\SubscribeEvent $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubscribeEvent($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SubscribeEventWithSitesFilters
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: UserSessionCredentials
     * - SOAPHeaderNamespaces: http://www.peoplevox.net/
     * - SOAPHeaderTypes: \http://www.peoplevox.net/\StructType\UserSessionCredentials
     * - SOAPHeaders: required
     * - documentation: Subscribe to PeopleVox system events wits sites filters.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \http://www.peoplevox.net/\StructType\SubscribeEventWithSitesFilters $parameters
     * @return \http://www.peoplevox.net/\StructType\SubscribeEventWithSitesFiltersResponse|bool
     */
    public function SubscribeEventWithSitesFilters(\http://www.peoplevox.net/\StructType\SubscribeEventWithSitesFilters $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubscribeEventWithSitesFilters($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named SubscribePostEvent
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: UserSessionCredentials
     * - SOAPHeaderNamespaces: http://www.peoplevox.net/
     * - SOAPHeaderTypes: \http://www.peoplevox.net/\StructType\UserSessionCredentials
     * - SOAPHeaders: required
     * - documentation: Subscribe to PeopleVox system events.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \http://www.peoplevox.net/\StructType\SubscribePostEvent $parameters
     * @return \http://www.peoplevox.net/\StructType\SubscribePostEventResponse|bool
     */
    public function SubscribePostEvent(\http://www.peoplevox.net/\StructType\SubscribePostEvent $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->SubscribePostEvent($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \http://www.peoplevox.net/\StructType\SubscribeEventResponse|\http://www.peoplevox.net/\StructType\SubscribeEventWithSitesFiltersResponse|\http://www.peoplevox.net/\StructType\SubscribePostEventResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
